<script setup>
import { ref } from "vue";
import { MyTask, FinishedTask, DeletedTask } from "../composables/Task";
let task = ref(null);
let form = ref(null);
let selectedTodo = ref(null);
const addTodo = () => {
  let id = MyTask.value.length;
  MyTask.value.push({
    id: ++id,
    todo: task.value,
  });
  task.value = null;
  form.value.reset();
};

const selectTodo = (row) => {
  selectedTodo.value = row;
  task.value = row.todo;
};
const updateTodo = () => {
  let index = MyTask.value.findIndex((t) => t.id === selectedTodo.value.id);
  index !== -1 && (MyTask.value[index].todo = task.value);
  task.value = selectedTodo.value = null;
  form.value.reset();
};
let toMarkAsDone = ref(null);
let showDialog = ref(false);
const toggleDialog = (row, status) => {
  showDialog.value = true;
  toMarkAsDone.value = toDelete.value = null;
  status !== "deleted" ? (toMarkAsDone.value = row) : (toDelete.value = row);
  console.log(toMarkAsDone);
};

const markAsDone = () => {
  let index = MyTask.value.findIndex((t) => t.id === toMarkAsDone.value.id);
  index !== -1 && MyTask.value.splice(index, 1);
  FinishedTask.value.push(toMarkAsDone.value);
  toMarkAsDone.value = null;
  task.value = null;
  form.value.reset();
  showDialog.value = false;
};
let toDelete = ref(null);
const Deleted = () => {
  let index = MyTask.value.findIndex((t) => t.id === toDelete.value.id);
  index !== -1 && MyTask.value.splice(index, 1);
  DeletedTask.value.push(toDelete.value);
  toMarkAsDone.value = null;
  task.value = null;
  form.value.reset();
  showDialog.value = false;
};
</script>

<template>
  <div class="flex justify-center">
    <div class="full-width q-pa-xl">
      <q-card class="my-card">
        <!--Head card-->
        <q-card-section>
          <h6 class="text-bold text-grey-9 q-my-none q-mb-md">My Tasks</h6>
          <q-form
            ref="form"
            @submit.prevent="!selectedTodo ? addTodo() : updateTodo()"
          >
            <div class="row gap">
              <q-input
                v-model="task"
                dense
                outlined
                label="What's your todo?"
                class="q-pa-none col-10"
                lazy-rules
                :rules="[(val) => !!val || 'Field is required']"
              />
              <div class="col-2 q-pl-sm">
                <q-btn
                  :class="`bg-${
                    !selectedTodo
                      ? 'purple-3 text-white'
                      : 'light-blue-11 text-white'
                  } fit`"
                  dense
                  type="submit"
                  :icon="!selectedTodo ? 'add' : 'edit'"
                />
              </div>
            </div>
          </q-form>
          <div class="q-mt-xl">
            <q-card
              @click="selectTodo(row)"
              class="q-mt-sm"
              v-for="row in MyTask"
              :key="row.id"
            >
              <q-card-section
                class="shadow-1 text-grey-10 q-pb-sm flex justify-between items-center"
              >
                <div class="text-h6 q-pl-sm">{{ row.todo }}</div>
                <q-fab
                  color="purple-3"
                  push
                  icon="keyboard_arrow_left"
                  direction="left"
                >
                  <q-fab-action
                    @click.stop="toggleDialog(row, 'checked')"
                    color="green"
                    icon="check"
                  />
                  <q-fab-action
                    color="red"
                    @click.stop="toggleDialog(row, 'deleted')"
                    icon="delete"
                  />
                </q-fab>
              </q-card-section>
            </q-card>
            <q-dialog v-model="showDialog" persistent>
              <q-card>
                <q-card-section class="row items-center">
                  <div v-if="toMarkAsDone" class="q-ml-sm">
                    Are you sure you want to mark
                    <span class="text-green">"{{ toMarkAsDone.todo }}"</span> as
                    done?
                  </div>
                  <div v-else class="q-ml-sm">
                    Are you sure you want to delete
                    <span class="text-green">"{{ toDelete.todo }}"</span>?
                  </div>
                </q-card-section>

                <q-card-actions align="right">
                  <q-btn flat label="Cancel" color="primary" v-close-popup />
                  <q-btn
                    @click="toMarkAsDone ? markAsDone() : Deleted()"
                    flat
                    label="Yes"
                    color="primary"
                    v-close-popup
                  />
                </q-card-actions>
              </q-card>
            </q-dialog>
          </div>
        </q-card-section>
      </q-card>
    </div>
  </div>
</template>
